/* SunriseSunsetCalculator.c generated by valac 0.56.11, the Vala compiler
 * generated from SunriseSunsetCalculator.vala, do not modify */

/*
* Copyright 2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
*/
/*
* The following code was ported from gnome-settings-daemon
* https://gitlab.gnome.org/GNOME/gnome-settings-daemon/-/blob/02295dee94bebcdd246c40ccf0120eb2ab714416/plugins/color/gsd-night-light-common.c
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR (settings_daemon_utils_sunrise_sunset_calculator_get_type ())
#define SETTINGS_DAEMON_UTILS_SUNRISE_SUNSET_CALCULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR, SettingsDaemonUtilsSunriseSunsetCalculator))
#define SETTINGS_DAEMON_UTILS_SUNRISE_SUNSET_CALCULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR, SettingsDaemonUtilsSunriseSunsetCalculatorClass))
#define SETTINGS_DAEMON_UTILS_IS_SUNRISE_SUNSET_CALCULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR))
#define SETTINGS_DAEMON_UTILS_IS_SUNRISE_SUNSET_CALCULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR))
#define SETTINGS_DAEMON_UTILS_SUNRISE_SUNSET_CALCULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR, SettingsDaemonUtilsSunriseSunsetCalculatorClass))

typedef struct _SettingsDaemonUtilsSunriseSunsetCalculator SettingsDaemonUtilsSunriseSunsetCalculator;
typedef struct _SettingsDaemonUtilsSunriseSunsetCalculatorClass SettingsDaemonUtilsSunriseSunsetCalculatorClass;
typedef struct _SettingsDaemonUtilsSunriseSunsetCalculatorPrivate SettingsDaemonUtilsSunriseSunsetCalculatorPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _SettingsDaemonUtilsParamSpecSunriseSunsetCalculator SettingsDaemonUtilsParamSpecSunriseSunsetCalculator;

struct _SettingsDaemonUtilsSunriseSunsetCalculator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SettingsDaemonUtilsSunriseSunsetCalculatorPrivate * priv;
};

struct _SettingsDaemonUtilsSunriseSunsetCalculatorClass {
	GTypeClass parent_class;
	void (*finalize) (SettingsDaemonUtilsSunriseSunsetCalculator *self);
};

struct _SettingsDaemonUtilsParamSpecSunriseSunsetCalculator {
	GParamSpec parent_instance;
};

static gpointer settings_daemon_utils_sunrise_sunset_calculator_parent_class = NULL;

VALA_EXTERN gpointer settings_daemon_utils_sunrise_sunset_calculator_ref (gpointer instance);
VALA_EXTERN void settings_daemon_utils_sunrise_sunset_calculator_unref (gpointer instance);
VALA_EXTERN GParamSpec* settings_daemon_utils_param_spec_sunrise_sunset_calculator (const gchar* name,
                                                                        const gchar* nick,
                                                                        const gchar* blurb,
                                                                        GType object_type,
                                                                        GParamFlags flags);
VALA_EXTERN void settings_daemon_utils_value_set_sunrise_sunset_calculator (GValue* value,
                                                                gpointer v_object);
VALA_EXTERN void settings_daemon_utils_value_take_sunrise_sunset_calculator (GValue* value,
                                                                 gpointer v_object);
VALA_EXTERN gpointer settings_daemon_utils_value_get_sunrise_sunset_calculator (const GValue* value);
VALA_EXTERN GType settings_daemon_utils_sunrise_sunset_calculator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SettingsDaemonUtilsSunriseSunsetCalculator, settings_daemon_utils_sunrise_sunset_calculator_unref)
VALA_EXTERN gboolean settings_daemon_utils_sunrise_sunset_calculator_get_sunrise_and_sunset (GDateTime* dt,
                                                                                 gdouble pos_lat,
                                                                                 gdouble pos_long,
                                                                                 gdouble* sunrise,
                                                                                 gdouble* sunset);
static gdouble settings_daemon_utils_sunrise_sunset_calculator_deg2rad (gdouble degrees);
static gdouble settings_daemon_utils_sunrise_sunset_calculator_rad2deg (gdouble radians);
VALA_EXTERN SettingsDaemonUtilsSunriseSunsetCalculator* settings_daemon_utils_sunrise_sunset_calculator_new (void);
VALA_EXTERN SettingsDaemonUtilsSunriseSunsetCalculator* settings_daemon_utils_sunrise_sunset_calculator_construct (GType object_type);
static void settings_daemon_utils_sunrise_sunset_calculator_finalize (SettingsDaemonUtilsSunriseSunsetCalculator * obj);
static GType settings_daemon_utils_sunrise_sunset_calculator_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gboolean
settings_daemon_utils_sunrise_sunset_calculator_get_sunrise_and_sunset (GDateTime* dt,
                                                                        gdouble pos_lat,
                                                                        gdouble pos_long,
                                                                        gdouble* sunrise,
                                                                        gdouble* sunset)
{
	gdouble _vala_sunrise = 0.0;
	gdouble _vala_sunset = 0.0;
	GDateTime* dt_zero = NULL;
	GDateTime* _tmp0_;
	GTimeSpan ts = 0LL;
	GDateTime* _tmp1_;
#line 35 "../src/Utils/SunriseSunsetCalculator.vala"
	static const gint _G_USEC_PER_SEC = 1000000;
#line 120 "SunriseSunsetCalculator.c"
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gdouble tz_offset = 0.0;
	gdouble date_as_number = 0.0;
	gdouble time_past_local_midnight = 0.0;
	gdouble julian_day = 0.0;
	gdouble julian_century = 0.0;
	gdouble geom_mean_long_sun = 0.0;
	gdouble geom_mean_anom_sun = 0.0;
	gdouble eccent_earth_orbit = 0.0;
	gdouble sun_eq_of_ctr = 0.0;
	gdouble sun_true_long = 0.0;
	gdouble sun_app_long = 0.0;
	gdouble mean_obliq_ecliptic = 0.0;
	gdouble obliq_corr = 0.0;
	gdouble sun_declin = 0.0;
	gdouble var_y = 0.0;
	gdouble eq_of_time = 0.0;
	gdouble ha_sunrise = 0.0;
	gdouble solar_noon = 0.0;
	gdouble sunrise_time = 0.0;
	gdouble sunset_time = 0.0;
	gboolean result;
#line 28 "../src/Utils/SunriseSunsetCalculator.vala"
	g_return_val_if_fail (dt != NULL, FALSE);
#line 29 "../src/Utils/SunriseSunsetCalculator.vala"
	_vala_sunrise = -1.0;
#line 30 "../src/Utils/SunriseSunsetCalculator.vala"
	_vala_sunset = -1.0;
#line 32 "../src/Utils/SunriseSunsetCalculator.vala"
	_tmp0_ = g_date_time_new_utc (1900, 1, 1, 0, 0, (gdouble) 0);
#line 32 "../src/Utils/SunriseSunsetCalculator.vala"
	dt_zero = _tmp0_;
#line 33 "../src/Utils/SunriseSunsetCalculator.vala"
	_tmp1_ = dt_zero;
#line 33 "../src/Utils/SunriseSunsetCalculator.vala"
	ts = g_date_time_difference (dt, _tmp1_);
#line 37 "../src/Utils/SunriseSunsetCalculator.vala"
	if (pos_lat <= ((gdouble) 90.0f)) {
#line 37 "../src/Utils/SunriseSunsetCalculator.vala"
		_tmp2_ = pos_lat >= ((gdouble) (-90.0f));
#line 162 "SunriseSunsetCalculator.c"
	} else {
#line 37 "../src/Utils/SunriseSunsetCalculator.vala"
		_tmp2_ = FALSE;
#line 166 "SunriseSunsetCalculator.c"
	}
#line 37 "../src/Utils/SunriseSunsetCalculator.vala"
	if (!_tmp2_) {
#line 38 "../src/Utils/SunriseSunsetCalculator.vala"
		result = FALSE;
#line 38 "../src/Utils/SunriseSunsetCalculator.vala"
		_g_date_time_unref0 (dt_zero);
#line 38 "../src/Utils/SunriseSunsetCalculator.vala"
		if (sunrise) {
#line 38 "../src/Utils/SunriseSunsetCalculator.vala"
			*sunrise = _vala_sunrise;
#line 178 "SunriseSunsetCalculator.c"
		}
#line 38 "../src/Utils/SunriseSunsetCalculator.vala"
		if (sunset) {
#line 38 "../src/Utils/SunriseSunsetCalculator.vala"
			*sunset = _vala_sunset;
#line 184 "SunriseSunsetCalculator.c"
		}
#line 38 "../src/Utils/SunriseSunsetCalculator.vala"
		return result;
#line 188 "SunriseSunsetCalculator.c"
	}
#line 41 "../src/Utils/SunriseSunsetCalculator.vala"
	if (pos_long <= ((gdouble) 180.0f)) {
#line 41 "../src/Utils/SunriseSunsetCalculator.vala"
		_tmp3_ = pos_long >= ((gdouble) (-180.0f));
#line 194 "SunriseSunsetCalculator.c"
	} else {
#line 41 "../src/Utils/SunriseSunsetCalculator.vala"
		_tmp3_ = FALSE;
#line 198 "SunriseSunsetCalculator.c"
	}
#line 41 "../src/Utils/SunriseSunsetCalculator.vala"
	if (!_tmp3_) {
#line 42 "../src/Utils/SunriseSunsetCalculator.vala"
		result = FALSE;
#line 42 "../src/Utils/SunriseSunsetCalculator.vala"
		_g_date_time_unref0 (dt_zero);
#line 42 "../src/Utils/SunriseSunsetCalculator.vala"
		if (sunrise) {
#line 42 "../src/Utils/SunriseSunsetCalculator.vala"
			*sunrise = _vala_sunrise;
#line 210 "SunriseSunsetCalculator.c"
		}
#line 42 "../src/Utils/SunriseSunsetCalculator.vala"
		if (sunset) {
#line 42 "../src/Utils/SunriseSunsetCalculator.vala"
			*sunset = _vala_sunset;
#line 216 "SunriseSunsetCalculator.c"
		}
#line 42 "../src/Utils/SunriseSunsetCalculator.vala"
		return result;
#line 220 "SunriseSunsetCalculator.c"
	}
#line 45 "../src/Utils/SunriseSunsetCalculator.vala"
	tz_offset = ((((gdouble) g_date_time_get_utc_offset (dt)) / _G_USEC_PER_SEC) / 60) / 60;
#line 46 "../src/Utils/SunriseSunsetCalculator.vala"
	date_as_number = (gdouble) (((((ts / _G_USEC_PER_SEC) / 24) / 60) / 60) + 2);
#line 47 "../src/Utils/SunriseSunsetCalculator.vala"
	time_past_local_midnight = (gdouble) 0;
#line 48 "../src/Utils/SunriseSunsetCalculator.vala"
	julian_day = ((date_as_number + 2415018.5) + time_past_local_midnight) - (tz_offset / 24);
#line 50 "../src/Utils/SunriseSunsetCalculator.vala"
	julian_century = (julian_day - 2451545) / 36525;
#line 51 "../src/Utils/SunriseSunsetCalculator.vala"
	geom_mean_long_sun = fmod (280.46646 + (julian_century * (36000.76983 + (julian_century * 0.0003032))), (gdouble) 360);
#line 53 "../src/Utils/SunriseSunsetCalculator.vala"
	geom_mean_anom_sun = 357.52911 + (julian_century * (35999.05029 - (0.0001537 * julian_century)));
#line 55 "../src/Utils/SunriseSunsetCalculator.vala"
	eccent_earth_orbit = 0.016708634 - (julian_century * (0.000042037 + (0.0000001267 * julian_century)));
#line 57 "../src/Utils/SunriseSunsetCalculator.vala"
	sun_eq_of_ctr = ((sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (geom_mean_anom_sun)) * (1.914602 - (julian_century * (0.004817 + (0.000014 * julian_century))))) + (sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (2 * geom_mean_anom_sun)) * (0.019993 - (0.000101 * julian_century)))) + (sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (3 * geom_mean_anom_sun)) * 0.000289);
#line 61 "../src/Utils/SunriseSunsetCalculator.vala"
	sun_true_long = geom_mean_long_sun + sun_eq_of_ctr;
#line 62 "../src/Utils/SunriseSunsetCalculator.vala"
	sun_app_long = (sun_true_long - 0.00569) - (0.00478 * sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (125.04 - (1934.136 * julian_century))));
#line 64 "../src/Utils/SunriseSunsetCalculator.vala"
	mean_obliq_ecliptic = 23 + ((26 + ((21.448 - (julian_century * (46.815 + (julian_century * (0.00059 - (julian_century * 0.001813)))))) / 60)) / 60);
#line 66 "../src/Utils/SunriseSunsetCalculator.vala"
	obliq_corr = mean_obliq_ecliptic + (0.00256 * cos (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (125.04 - (1934.136 * julian_century))));
#line 68 "../src/Utils/SunriseSunsetCalculator.vala"
	sun_declin = settings_daemon_utils_sunrise_sunset_calculator_rad2deg (asin (sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (obliq_corr)) * sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (sun_app_long))));
#line 70 "../src/Utils/SunriseSunsetCalculator.vala"
	var_y = tan (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (obliq_corr / 2)) * tan (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (obliq_corr / 2));
#line 71 "../src/Utils/SunriseSunsetCalculator.vala"
	eq_of_time = 4 * settings_daemon_utils_sunrise_sunset_calculator_rad2deg (((((var_y * sin (2 * settings_daemon_utils_sunrise_sunset_calculator_deg2rad (geom_mean_long_sun))) - ((2 * eccent_earth_orbit) * sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (geom_mean_anom_sun)))) + ((((4 * eccent_earth_orbit) * var_y) * sin (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (geom_mean_anom_sun))) * cos (2 * settings_daemon_utils_sunrise_sunset_calculator_deg2rad (geom_mean_long_sun)))) - (((0.5 * var_y) * var_y) * sin (4 * settings_daemon_utils_sunrise_sunset_calculator_deg2rad (geom_mean_long_sun)))) - (((1.25 * eccent_earth_orbit) * eccent_earth_orbit) * sin (2 * settings_daemon_utils_sunrise_sunset_calculator_deg2rad (geom_mean_anom_sun))));
#line 79 "../src/Utils/SunriseSunsetCalculator.vala"
	ha_sunrise = settings_daemon_utils_sunrise_sunset_calculator_rad2deg (acos ((cos (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (90.833)) / (cos (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (pos_lat)) * cos (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (sun_declin)))) - (tan (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (pos_lat)) * tan (settings_daemon_utils_sunrise_sunset_calculator_deg2rad (sun_declin)))));
#line 82 "../src/Utils/SunriseSunsetCalculator.vala"
	solar_noon = (((720 - (4 * pos_long)) - eq_of_time) + (tz_offset * 60)) / 1440;
#line 83 "../src/Utils/SunriseSunsetCalculator.vala"
	sunrise_time = solar_noon - ((ha_sunrise * 4) / 1440);
#line 84 "../src/Utils/SunriseSunsetCalculator.vala"
	sunset_time = solar_noon + ((ha_sunrise * 4) / 1440);
#line 86 "../src/Utils/SunriseSunsetCalculator.vala"
	_vala_sunrise = sunrise_time * 24;
#line 87 "../src/Utils/SunriseSunsetCalculator.vala"
	_vala_sunset = sunset_time * 24;
#line 89 "../src/Utils/SunriseSunsetCalculator.vala"
	result = TRUE;
#line 89 "../src/Utils/SunriseSunsetCalculator.vala"
	_g_date_time_unref0 (dt_zero);
#line 89 "../src/Utils/SunriseSunsetCalculator.vala"
	if (sunrise) {
#line 89 "../src/Utils/SunriseSunsetCalculator.vala"
		*sunrise = _vala_sunrise;
#line 274 "SunriseSunsetCalculator.c"
	}
#line 89 "../src/Utils/SunriseSunsetCalculator.vala"
	if (sunset) {
#line 89 "../src/Utils/SunriseSunsetCalculator.vala"
		*sunset = _vala_sunset;
#line 280 "SunriseSunsetCalculator.c"
	}
#line 89 "../src/Utils/SunriseSunsetCalculator.vala"
	return result;
#line 284 "SunriseSunsetCalculator.c"
}

static gdouble
settings_daemon_utils_sunrise_sunset_calculator_deg2rad (gdouble degrees)
{
	gdouble result;
#line 93 "../src/Utils/SunriseSunsetCalculator.vala"
	result = (G_PI * degrees) / 180.0f;
#line 93 "../src/Utils/SunriseSunsetCalculator.vala"
	return result;
#line 295 "SunriseSunsetCalculator.c"
}

static gdouble
settings_daemon_utils_sunrise_sunset_calculator_rad2deg (gdouble radians)
{
	gdouble result;
#line 97 "../src/Utils/SunriseSunsetCalculator.vala"
	result = radians * (180.0f / G_PI);
#line 97 "../src/Utils/SunriseSunsetCalculator.vala"
	return result;
#line 306 "SunriseSunsetCalculator.c"
}

SettingsDaemonUtilsSunriseSunsetCalculator*
settings_daemon_utils_sunrise_sunset_calculator_construct (GType object_type)
{
	SettingsDaemonUtilsSunriseSunsetCalculator* self = NULL;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	self = (SettingsDaemonUtilsSunriseSunsetCalculator*) g_type_create_instance (object_type);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return self;
#line 317 "SunriseSunsetCalculator.c"
}

SettingsDaemonUtilsSunriseSunsetCalculator*
settings_daemon_utils_sunrise_sunset_calculator_new (void)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return settings_daemon_utils_sunrise_sunset_calculator_construct (SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR);
#line 325 "SunriseSunsetCalculator.c"
}

static void
settings_daemon_utils_value_sunrise_sunset_calculator_init (GValue* value)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	value->data[0].v_pointer = NULL;
#line 333 "SunriseSunsetCalculator.c"
}

static void
settings_daemon_utils_value_sunrise_sunset_calculator_free_value (GValue* value)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (value->data[0].v_pointer) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		settings_daemon_utils_sunrise_sunset_calculator_unref (value->data[0].v_pointer);
#line 343 "SunriseSunsetCalculator.c"
	}
}

static void
settings_daemon_utils_value_sunrise_sunset_calculator_copy_value (const GValue* src_value,
                                                                  GValue* dest_value)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		dest_value->data[0].v_pointer = settings_daemon_utils_sunrise_sunset_calculator_ref (src_value->data[0].v_pointer);
#line 355 "SunriseSunsetCalculator.c"
	} else {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		dest_value->data[0].v_pointer = NULL;
#line 359 "SunriseSunsetCalculator.c"
	}
}

static gpointer
settings_daemon_utils_value_sunrise_sunset_calculator_peek_pointer (const GValue* value)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return value->data[0].v_pointer;
#line 368 "SunriseSunsetCalculator.c"
}

static gchar*
settings_daemon_utils_value_sunrise_sunset_calculator_collect_value (GValue* value,
                                                                     guint n_collect_values,
                                                                     GTypeCValue* collect_values,
                                                                     guint collect_flags)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (collect_values[0].v_pointer) {
#line 379 "SunriseSunsetCalculator.c"
		SettingsDaemonUtilsSunriseSunsetCalculator * object;
		object = collect_values[0].v_pointer;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 386 "SunriseSunsetCalculator.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 390 "SunriseSunsetCalculator.c"
		}
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		value->data[0].v_pointer = settings_daemon_utils_sunrise_sunset_calculator_ref (object);
#line 394 "SunriseSunsetCalculator.c"
	} else {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		value->data[0].v_pointer = NULL;
#line 398 "SunriseSunsetCalculator.c"
	}
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return NULL;
#line 402 "SunriseSunsetCalculator.c"
}

static gchar*
settings_daemon_utils_value_sunrise_sunset_calculator_lcopy_value (const GValue* value,
                                                                   guint n_collect_values,
                                                                   GTypeCValue* collect_values,
                                                                   guint collect_flags)
{
	SettingsDaemonUtilsSunriseSunsetCalculator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (!object_p) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 417 "SunriseSunsetCalculator.c"
	}
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		*object_p = NULL;
#line 423 "SunriseSunsetCalculator.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		*object_p = value->data[0].v_pointer;
#line 427 "SunriseSunsetCalculator.c"
	} else {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		*object_p = settings_daemon_utils_sunrise_sunset_calculator_ref (value->data[0].v_pointer);
#line 431 "SunriseSunsetCalculator.c"
	}
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return NULL;
#line 435 "SunriseSunsetCalculator.c"
}

GParamSpec*
settings_daemon_utils_param_spec_sunrise_sunset_calculator (const gchar* name,
                                                            const gchar* nick,
                                                            const gchar* blurb,
                                                            GType object_type,
                                                            GParamFlags flags)
{
	SettingsDaemonUtilsParamSpecSunriseSunsetCalculator* spec;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR), NULL);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return G_PARAM_SPEC (spec);
#line 454 "SunriseSunsetCalculator.c"
}

gpointer
settings_daemon_utils_value_get_sunrise_sunset_calculator (const GValue* value)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR), NULL);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return value->data[0].v_pointer;
#line 464 "SunriseSunsetCalculator.c"
}

void
settings_daemon_utils_value_set_sunrise_sunset_calculator (GValue* value,
                                                           gpointer v_object)
{
	SettingsDaemonUtilsSunriseSunsetCalculator * old;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR));
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (v_object) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR));
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		settings_daemon_utils_sunrise_sunset_calculator_ref (value->data[0].v_pointer);
#line 486 "SunriseSunsetCalculator.c"
	} else {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		value->data[0].v_pointer = NULL;
#line 490 "SunriseSunsetCalculator.c"
	}
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (old) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		settings_daemon_utils_sunrise_sunset_calculator_unref (old);
#line 496 "SunriseSunsetCalculator.c"
	}
}

void
settings_daemon_utils_value_take_sunrise_sunset_calculator (GValue* value,
                                                            gpointer v_object)
{
	SettingsDaemonUtilsSunriseSunsetCalculator * old;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR));
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (v_object) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR));
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		value->data[0].v_pointer = v_object;
#line 517 "SunriseSunsetCalculator.c"
	} else {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		value->data[0].v_pointer = NULL;
#line 521 "SunriseSunsetCalculator.c"
	}
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (old) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		settings_daemon_utils_sunrise_sunset_calculator_unref (old);
#line 527 "SunriseSunsetCalculator.c"
	}
}

static void
settings_daemon_utils_sunrise_sunset_calculator_class_init (SettingsDaemonUtilsSunriseSunsetCalculatorClass * klass,
                                                            gpointer klass_data)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	settings_daemon_utils_sunrise_sunset_calculator_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	((SettingsDaemonUtilsSunriseSunsetCalculatorClass *) klass)->finalize = settings_daemon_utils_sunrise_sunset_calculator_finalize;
#line 539 "SunriseSunsetCalculator.c"
}

static void
settings_daemon_utils_sunrise_sunset_calculator_instance_init (SettingsDaemonUtilsSunriseSunsetCalculator * self,
                                                               gpointer klass)
{
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	self->ref_count = 1;
#line 548 "SunriseSunsetCalculator.c"
}

static void
settings_daemon_utils_sunrise_sunset_calculator_finalize (SettingsDaemonUtilsSunriseSunsetCalculator * obj)
{
	SettingsDaemonUtilsSunriseSunsetCalculator * self;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SETTINGS_DAEMON_UTILS_TYPE_SUNRISE_SUNSET_CALCULATOR, SettingsDaemonUtilsSunriseSunsetCalculator);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	g_signal_handlers_destroy (self);
#line 559 "SunriseSunsetCalculator.c"
}

static GType
settings_daemon_utils_sunrise_sunset_calculator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { settings_daemon_utils_value_sunrise_sunset_calculator_init, settings_daemon_utils_value_sunrise_sunset_calculator_free_value, settings_daemon_utils_value_sunrise_sunset_calculator_copy_value, settings_daemon_utils_value_sunrise_sunset_calculator_peek_pointer, "p", settings_daemon_utils_value_sunrise_sunset_calculator_collect_value, "p", settings_daemon_utils_value_sunrise_sunset_calculator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SettingsDaemonUtilsSunriseSunsetCalculatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_daemon_utils_sunrise_sunset_calculator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SettingsDaemonUtilsSunriseSunsetCalculator), 0, (GInstanceInitFunc) settings_daemon_utils_sunrise_sunset_calculator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType settings_daemon_utils_sunrise_sunset_calculator_type_id;
	settings_daemon_utils_sunrise_sunset_calculator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SettingsDaemonUtilsSunriseSunsetCalculator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return settings_daemon_utils_sunrise_sunset_calculator_type_id;
}

GType
settings_daemon_utils_sunrise_sunset_calculator_get_type (void)
{
	static volatile gsize settings_daemon_utils_sunrise_sunset_calculator_type_id__once = 0;
	if (g_once_init_enter (&settings_daemon_utils_sunrise_sunset_calculator_type_id__once)) {
		GType settings_daemon_utils_sunrise_sunset_calculator_type_id;
		settings_daemon_utils_sunrise_sunset_calculator_type_id = settings_daemon_utils_sunrise_sunset_calculator_get_type_once ();
		g_once_init_leave (&settings_daemon_utils_sunrise_sunset_calculator_type_id__once, settings_daemon_utils_sunrise_sunset_calculator_type_id);
	}
	return settings_daemon_utils_sunrise_sunset_calculator_type_id__once;
}

gpointer
settings_daemon_utils_sunrise_sunset_calculator_ref (gpointer instance)
{
	SettingsDaemonUtilsSunriseSunsetCalculator * self;
	self = instance;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	return instance;
#line 594 "SunriseSunsetCalculator.c"
}

void
settings_daemon_utils_sunrise_sunset_calculator_unref (gpointer instance)
{
	SettingsDaemonUtilsSunriseSunsetCalculator * self;
	self = instance;
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		SETTINGS_DAEMON_UTILS_SUNRISE_SUNSET_CALCULATOR_GET_CLASS (self)->finalize (self);
#line 27 "../src/Utils/SunriseSunsetCalculator.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 608 "SunriseSunsetCalculator.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

